// Based upon 'custominitcd' module by ffgriever

#include <tamtypes.h>
#include <stdio.h>

#define CDVD_BASE	0x1F402000

#define DEBUG	1

void cdvdWrite(u8 reg, u8 val)
{
	#ifdef DEBUG
		printf("cdvdWrite%02x, val = 0x%02x\n", reg, val);
	#endif

	_sb(val, CDVD_BASE+reg);
}

void cdvdRead(u8 reg)
{
	u8 val = _lb(CDVD_BASE+reg);

	#ifdef DEBUG
		printf("cdvdRead%02X = 0x%02x\n", reg, val);
	#endif
}

void read1()
{
	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);
}


void Init_1(u8 val1, u8 val2, u8 val3, u8 val4)
{
	cdvdRead(0x05);
	cdvdRead(0x05);
	cdvdRead(0x17);
	cdvdRead(0x17);

	cdvdWrite(0x17, val1);
	cdvdWrite(0x17, val2);
	cdvdWrite(0x17, val3);
	cdvdWrite(0x16, 0x40);
	
	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);
	
	u32 i;

	for(i=0; i < val4; i++)
	{
		cdvdWrite(0x16, 0x41);
	
		cdvdRead(0x16);
		cdvdRead(0x17);
		cdvdRead(0x17);

		u32 j;

		for(j=0; j < 16; j++)
		{		
			cdvdRead(0x18);		
			cdvdRead(0x17);
		}

		cdvdRead(0x17);
		cdvdRead(0x17);
	}
	
	cdvdWrite(0x16, 0x43);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);
}



void Init_2()
{
	cdvdRead(0x17);
	cdvdRead(0x17);
	
	cdvdWrite(0x17, 0x00);
	cdvdWrite(0x16, 0x80);

	read1();

	cdvdWrite(0x17, 0x00);
	cdvdWrite(0x16, 0x81);

	read1();

	u32 i;

	for(i=0; i < 16; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x82);

	read1();

	for(i=0; i < 8; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x83);

	read1();

	cdvdWrite(0x16, 0x8F);

	read1();

	cdvdWrite(0x16, 0x84);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 13; i++)
	{		
		cdvdRead(0x18);		
		cdvdRead(0x17);
	}

	cdvdRead(0x17);
	cdvdRead(0x17);

	cdvdWrite(0x16, 0x85);
	
	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 13; i++)
	{		
		cdvdRead(0x18);		
		cdvdRead(0x17);
	}

	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 16; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x86);

	read1();

	for(i=0; i < 8; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x87);

	read1();

	cdvdWrite(0x16, 0x8F);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);
	cdvdRead(0x17);

	cdvdWrite(0x16, 0x88);	

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);

	cdvdWrite(0x17, 0x08);
	cdvdWrite(0x16, 0x80);

	read1();
	
	cdvdWrite(0x17, 0x08);
	cdvdWrite(0x16, 0x81);

	read1();

	for(i=0; i < 16; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x82);
	
	read1();

	for(i=0; i < 8; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x83);

	read1();

	cdvdWrite(0x16, 0x8f);
	
	read1();

	cdvdWrite(0x16, 0x84);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 13; i++)
	{		
		cdvdRead(0x18);		
		cdvdRead(0x17);
	}

	cdvdRead(0x17);
	cdvdRead(0x17);

	cdvdWrite(0x16, 0x85);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 13; i++)
	{		
		cdvdRead(0x18);		
		cdvdRead(0x17);
	}

	cdvdRead(0x17);
	cdvdRead(0x17);

	for(i=0; i < 16; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x86);
	
	read1();

	for(i=0; i < 8; i++) cdvdWrite(0x17, 0xFF);

	cdvdWrite(0x16, 0x87);

	read1();

	cdvdWrite(0x16, 0x8F);

	read1();

	cdvdWrite(0x16, 0x88);

	read1();
}


void Init_3()
{
	cdvdRead(0x17);
	cdvdRead(0x17);
	
	cdvdWrite(0x17, 0x00);
	cdvdWrite(0x16, 0x03);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x18);
	cdvdRead(0x17);	
	cdvdRead(0x18);
	cdvdRead(0x17);	
	cdvdRead(0x18);
	cdvdRead(0x17);	
	cdvdRead(0x18);
	cdvdRead(0x17);

	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);
	cdvdRead(0x17);
}

void Init_4()
{
	cdvdWrite(0x17, 0x01);
	cdvdWrite(0x17, 0x5A);
	cdvdWrite(0x17, 0x45);
	cdvdWrite(0x17, 0x43);
	cdvdWrite(0x16, 0x1A);

	read1();

	cdvdWrite(0x16, 0x22);

	cdvdRead(0x16);
	cdvdRead(0x17);
	cdvdRead(0x17);

	u32 i;

	for(i=0; i < 10; i++)
	{		
		cdvdRead(0x18);		
		cdvdRead(0x17);
	}

	cdvdRead(0x17);
	cdvdRead(0x17);
}


int _start()
{
	Init_1(0x00, 0x00, 0x04, 0x04);
	Init_1(0x00, 0x01, 0x02, 0x02);
	
	cdvdRead(0x05);
	cdvdRead(0x05);
	cdvdRead(0x05);

	Init_1(0x00, 0x00, 0x04, 0x04);
	Init_1(0x00, 0x01, 0x02, 0x02);
	
	cdvdRead(0x05);
	cdvdRead(0x05);
	cdvdRead(0x05);
	cdvdRead(0x08);
	cdvdRead(0x08);

	Init_2();

	cdvdRead(0x08);
	cdvdRead(0x08);

	Init_3();

	Init_4();
	


	return 1;
}

